package yhq.jad.easydemo;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.Socket;
import java.net.URL;
import java.security.SecureRandom;
import java.util.ArrayList;
import java.util.HashMap;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;

import com.example.easyconfigdemo.R;
import com.example.rak415_scan_config.RAK415_Scan_Config;

import android.R.integer;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.graphics.Color;
import android.graphics.Paint;
import android.net.DhcpInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.format.Formatter;
import android.text.method.HideReturnsTransformationMethod;
import android.text.method.PasswordTransformationMethod;
import android.util.Base64;
import android.util.Log;
import android.view.Display;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

public class apconfig extends Activity 
{
	TextView Ap_statu;
	TextView Goto_easyconfig;
	TextView Goto_netswitch;
	EditText User_name;
	EditText User_Psk;
	EditText Ap_ssid;
	EditText Ap_psk;
	ImageButton Ap_scan;
	ImageButton Ap_eye;
	ProgressBar Ap_progress;
	Button Ap_config;//APģ
	Button Scan;//ɨģ
	ListView AP_Recvlist;//APɺɨ赽ģб 
	SimpleAdapter AP_RecvlistAdapter;
	ArrayList<HashMap<String, Object>> AP_RecvlistItem;
	
	Handler UI_Refresh_Handler=null;
	String dest_ip="";
	int dest_port=80;
	String mac="";
	//һWifiInfo  
	private WLANAPI mWifiAdmin;//wifi API
	
	//ssid
	String keyString="selectedSSIDChange(";
	String keyFlag="'";
	ArrayList<String> ssids = new ArrayList<String>();
	
	//ɨϢ
	byte[][] RAK415Info=null;
	ArrayList<RAKInfo> RAKNodes;
	RAKInfo node=null; 
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.apconfig);
		
		RAK415Info=new byte[100][43];//ɨ赽ģϢ
		RAKNodes = new ArrayList<RAKInfo>();//½һArrayListԴΪRAKInfo
				
		Ap_statu=(TextView)findViewById(R.id.ap_status);
		Goto_easyconfig=(TextView)findViewById(R.id.gotoeasyconfig);
		Goto_easyconfig.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG);
		Goto_easyconfig.setOnClickListener(Goto_easyconfig_click);
		Goto_netswitch=(TextView)findViewById(R.id.gotonetswitch);
		Goto_netswitch.getPaint().setFlags(Paint.UNDERLINE_TEXT_FLAG);
		Goto_netswitch.setOnClickListener(Goto_netswitchclick);
		User_name=(EditText)findViewById(R.id.user_name);
		User_Psk=(EditText)findViewById(R.id.user_psk);
		Ap_ssid=(EditText)findViewById(R.id.ap_ssid);
		Ap_psk=(EditText)findViewById(R.id.ap_psk);
		Ap_eye=(ImageButton)findViewById(R.id.ap_eye);
		Ap_eye.setOnClickListener(Ap_eye_click);
		Ap_scan=(ImageButton)findViewById(R.id.ap_scan);
		Ap_scan.setOnClickListener(Ap_scan_click);
		Ap_progress=(ProgressBar)findViewById(R.id.ap_progress);
		Ap_config=(Button)findViewById(R.id.ap_config);//APģ
		Ap_config.setOnClickListener(Ap_config_click);
		Scan=(Button)findViewById(R.id.scan_module);//ɨģ
		Scan.setOnClickListener(Scan_module_click);
		AP_Recvlist=(ListView)findViewById(R.id.AP_Recv_list);
		AP_RecvlistItem = new ArrayList<HashMap<String, Object>>();
		AP_RecvlistAdapter = new SimpleAdapter(
				this,AP_RecvlistItem, R.layout.list_item,
				new String[]
				{ "icon", "id", "info"}, 
				new int[]
				{ R.id.ItemIcon, R.id.easyconfig_id, 
						R.id.easyconfig_info });
		AP_Recvlist.setAdapter(AP_RecvlistAdapter);
		
		mWifiAdmin = new WLANAPI(this);
		UI_Refresh();// UI
	}
	
	/*
	 * UI
	 */
	int SHOW_NETWORK_LIST=0;	
	int CONFIG_SUCCESS=1;
	int SSID_IS_EMPTY=2;
	int CONNECT_DEVICE_FAILED=3;
	int RESET_SUCCESS=4;
	int SHOW_SCAN_DEVICE=5;
	int ERROR_CODE=6;
	String Error="";
	void UI_Refresh() 
	{	
		UI_Refresh_Handler = new Handler() 
		{  
            @Override  
            public void handleMessage(Message msg) 
            {  
                if(msg.what == SHOW_NETWORK_LIST) 
                {  
                	//ʾɨ赽
					if(ssids.size()>0)
					{
						AlertDialog.Builder builder = new AlertDialog.Builder(apconfig.this);
		                builder.setTitle("Choose a network");
		                //    ָбʾ
		                final String[] networks = new String[ssids.size()];
		                for(int n=0;n<ssids.size();n++)
		                {
		                	networks[n]=ssids.get(n).toString();
		                }
		                //    һбѡ
		                builder.setItems(networks, new DialogInterface.OnClickListener()
		                {
		                    @Override
		                    public void onClick(DialogInterface dialog, int which)
		                    {
		                    	Ap_ssid.setText(networks[which]);
		                    	//ȡ
		                		SharedPreferences p = getSharedPreferences(Ap_ssid.getText().toString(), MODE_PRIVATE);
		                  	  	String psk=p.getString("psk", "");
		                		Ap_psk.setText(psk);
		                    	dialog.dismiss();
		                    }
		                });
		                builder.show();
		                ssids.clear();
					} 
					else
					{
						DisplayToast("Get network list failed");
					}
                } 
                else if(msg.what == CONFIG_SUCCESS) 
                {
                	DisplayToast("Config success,reset device...");
				}
                else if(msg.what == SSID_IS_EMPTY) 
                {
                	DisplayToast("SSID can't be empty");
				}
                else if(msg.what == CONNECT_DEVICE_FAILED) 
                {
                	DisplayToast("Mobile phone didn't connect to RAK device");
				}
                else if(msg.what == RESET_SUCCESS) 
                {
                	DisplayToast("Reset success");
                	AlertDialog.Builder builder = new Builder(apconfig.this);
                	builder.setMessage("Switch to the network have configured");
                	builder.setTitle("Switch network");
                	builder.setPositiveButton("OK", new android.content.DialogInterface.OnClickListener()
                	{						
						@Override
						public void onClick(DialogInterface dialog, int arg1) 
						{
							// TODO Auto-generated method stub
							Intent intent = new Intent(android.provider.Settings.ACTION_WIFI_SETTINGS);
						    startActivity(intent);
							dialog.dismiss();
						}
					});
                	builder.create().show();
				}
                else if(msg.what == SHOW_SCAN_DEVICE) 
                {
                	Scan.setEnabled(true);
                	for(int i=0;i<100;i++)
    		        {
    		        	RAKNodes.add(new RAKInfo(RAK415Info[i]));//ȡɨ赽ģϢ  
    		        	node = RAKNodes.get(i);
    		        	if (node.Mac.equals("00:00:00:00:00:00")==false)//ݣMacȫΪ0Ļ
    					{	        		
    		        		//ӵбʾ
    		        		AP_AddListItem(node.Ip,node.Mac);		        		
    					}
    		        	else 
    		        	{
    						break;
    					}	        	
    		        }
    		        RAKNodes.clear();//ԭе               	
				}
                else if(msg.what == ERROR_CODE) 
                {
                	DisplayToast(Error);
				}
                
                super.handleMessage(msg);  
            }  
        };  
	}
	
	/*
	 * ǷӵRAKģ
	 */
	boolean Is_connect_rak=false;
	@Override
	protected void onResume() 
	{		
		super.onResume();
		if(mWifiAdmin.Wifi_Is_Open())
        {   
			mWifiAdmin = new WLANAPI(this);
			Is_connect_rak=false;			
			String get_mac=mWifiAdmin.getBSSID().toUpperCase();
			if(get_mac.startsWith("60:C5:A8:"))
			{				
				mac=get_mac;
				dest_ip=Formatter.formatIpAddress(mWifiAdmin.getGateway());
				Ap_statu.setTextColor(Color.WHITE);
				Ap_statu.setText("Have been connected to RAK device:"+mac);
				Is_connect_rak=true;
			}
			else
			{
				Ap_statu.setTextColor(Color.RED);
				Ap_statu.setText("Haven't been connected to RAK device");
			}
        }
		else
		{			
			Is_connect_rak=false;
			DisplayToast("The network is unavailable, please check the network");
		}	
	}
	
	/*
	 * Easyconfig
	 */
	OnClickListener Goto_easyconfig_click=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
			finish();
		}
	};
	
	/*
	 * л
	 */
	OnClickListener Goto_netswitchclick=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
			Intent intent = new Intent(android.provider.Settings.ACTION_WIFI_SETTINGS);
		    startActivity(intent);
		}
	};
		
	/*
	 * ʾʾ
	 */	
	boolean psk_open=false;//ʾ
	OnClickListener Ap_eye_click=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
			psk_open=!psk_open;
			if(psk_open)
			{
				//EditTextΪɼ
				Ap_psk.setTransformationMethod(HideReturnsTransformationMethod.getInstance());
				Ap_eye.setImageResource(R.drawable.eyeopen);
			}
			else 
			{
				//EditTextΪص
				Ap_psk.setTransformationMethod(PasswordTransformationMethod.getInstance());
				Ap_eye.setImageResource(R.drawable.eye);
			}
		}
	};
	
	
	/*
	 * ɨ
	 */
	boolean Is_scan_network=false;
	OnClickListener Ap_scan_click=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
			Is_scan_network=true;
			new Thread(Config_device).start();
		}
	};
	
	/*
	 * AP
	 */
	boolean Is_config=false;
	OnClickListener Ap_config_click=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
			//˺ź
			Editor editor = getSharedPreferences(Ap_ssid.getText().toString(), MODE_PRIVATE).edit();
		    editor.putString("psk", Ap_psk.getText().toString());
		    editor.commit();
		    Is_config=true;
		    new Thread(Config_device).start();   
		}
	};

	
	/*
	 * ɨģ
	 */
	boolean Is_scan_device=false;
	OnClickListener Scan_module_click=new OnClickListener() 
	{		
		@Override
		public void onClick(View v) 
		{
			// TODO Auto-generated method stub
      		if(mWifiAdmin.Wifi_Is_Open())
	        {    
      			Scan.setEnabled(false);//δɨֹٴɨ
      			mWifiAdmin = new WLANAPI(apconfig.this);     			
      			AP_RecvlistItem.clear();
      			AP_RecvlistAdapter.notifyDataSetChanged();
      			Is_scan_device=true;
      			new Thread(Config_device).start(); 
	        }
			else
			{			
				Is_connect_rak=false;
				DisplayToast("The network is unavailable, please check the network");
			}
	        
		}
	};
	
	/*
	 * б
	 */
	private void AP_AddListItem(String id, String info)
	{
		HashMap<String, Object> map = new HashMap<String, Object>();

		map.put("icon", R.drawable.item);

		map.put("id", id);
		map.put("info", info);			
		AP_RecvlistItem.add(map);	
		AP_RecvlistAdapter.notifyDataSetChanged();			
	}
	
	/*
	 * ɨ衢
	 */
	Runnable Config_device=new Runnable() 
	{		
		@Override
		public void run() 
		{
			// TODO Auto-generated method stub
			//ɨѾõģ
			if(Is_scan_device)
			{
				int x=~(mWifiAdmin.mDhcpInfo.netmask)|(mWifiAdmin.mDhcpInfo.gateway);//ȡؾ㲥ַ   
				String BoardCastIP=Formatter.formatIpAddress(x);	//ʼwifiȡع㲥ַ
				EasyDemo.lock.acquire();//udp㲥
				if(BoardCastIP!=null)
					RAK415Info=RAK415_Scan_Config.Scan(BoardCastIP);//ɨRAK415ģ飬ɨ赽ģϢ
		        EasyDemo.lock.release();//ͷ		        
		        Is_scan_device=false;
		        Message msg = new Message();  
                msg.what = SHOW_SCAN_DEVICE;  
                UI_Refresh_Handler.sendMessage(msg); 		        
			}
			else
			{
				if(Is_connect_rak)
				{	
					//֤Ϣ		
					String admin_info= User_name.getText().toString()+":"+User_Psk.getText().toString();
					admin_info=" Basic "+android.util.Base64.encodeToString(admin_info.getBytes(), Base64.NO_WRAP);

					//ȡɨ赽б
					if(Is_scan_network)
					{								
						String Recv_Str=GetHttps("http://"+dest_ip+":80/sta_search.html","",admin_info,"GET");					
						if(Recv_Str.equals("")==false)
						{
							if(Recv_Str.startsWith("ERROR:")==false)
							{
								ssids.clear();
								Is_scan_network=false;
								int position=0;
								for(int i=0;i<6;i++)
								{
									int index=Recv_Str.indexOf(keyString,position);
									if(index!=-1)
									{
										position=index+keyString.length();
										int index1=Recv_Str.indexOf(keyFlag,position);
										if(index1!=-1)
										{
											position=index1+keyFlag.length();
											int index2=Recv_Str.indexOf(keyFlag,position);
											if(index2!=-1)
											{
												ssids.add(Recv_Str.substring(position,index2));
												position=index2+keyFlag.length();
											}
											else
											{
												break;
											}
										}
										else
										{
											break;
										}									
									}
									else
									{
										break;
									}
								}
								Message msg = new Message();  
				                msg.what = SHOW_NETWORK_LIST;  
				                UI_Refresh_Handler.sendMessage(msg); 							
							}
							else
							{
								Error=Recv_Str;
								Message msg = new Message();  
				                msg.what = ERROR_CODE;  
				                UI_Refresh_Handler.sendMessage(msg); 
							}
						}					
						Is_scan_network=false;
					}
					//ģ
					if(Is_config)
					{
						//Ϣ
						String Ap_config_data="";
						if(Ap_ssid.getText().toString().equals(""))							
						{
							Message msg = new Message();  
			                msg.what = SSID_IS_EMPTY;  
			                UI_Refresh_Handler.sendMessage(msg);
						}
						else
						{
							if(Ap_psk.getText().toString().equals(""))
							{
								Ap_config_data="wifi_mode=STA&"+"sta_ssid="+Ap_ssid.getText().toString();
							}
							else
							{
								Ap_config_data="wifi_mode=STA&"+"sta_ssid="+Ap_ssid.getText().toString()+"&"+"sta_psk="+Ap_psk.getText().toString();	
							}
							//POST  ģ
							String Recv_Str=GetHttps("http://"+dest_ip+":80/save_success.html",Ap_config_data,admin_info,"POST");
							if(Recv_Str.equals("")==false)
							{
								if(Recv_Str.startsWith("ERROR:")==false)
								{
									Message msg = new Message();  
					                msg.what = CONFIG_SUCCESS;  
					                UI_Refresh_Handler.sendMessage(msg); 
					                //óɹλģ
					                Recv_Str=GetHttps("http://"+dest_ip+":80/reset_success.html","module_cmd=reset",admin_info,"POST");
					                if(Recv_Str.equals("")==false)
									{
										if(Recv_Str.startsWith("ERROR:")==false)
										{
											msg = new Message();  
							                msg.what = RESET_SUCCESS;  
							                UI_Refresh_Handler.sendMessage(msg); 
										}
										else
										{
											Error=Recv_Str;
											msg = new Message();  
							                msg.what = ERROR_CODE;  
							                UI_Refresh_Handler.sendMessage(msg); 
										}
									}
								}
								else
								{
									Error=Recv_Str;
									Message msg = new Message();  
					                msg.what = ERROR_CODE;  
					                UI_Refresh_Handler.sendMessage(msg); 
								}
							}
							Is_config=false;
						}
					}		
				}
				else
				{
					Message msg = new Message();  
	                msg.what = CONNECT_DEVICE_FAILED;  
	                UI_Refresh_Handler.sendMessage(msg); 
				}
			}
		
		}
	};

	
	/*
	 * ʾϢ
	 */
	public void DisplayToast(String str)
	{
		Toast.makeText(this, str, Toast.LENGTH_SHORT).show();
	}
	
	/*
	 * ˳
	 */
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event)
	{
		if (keyCode == KeyEvent.KEYCODE_BACK)
		{
			finish();
		}
		return false;
	}

	/*
	 * Http
	 */	
	String GetHttps(String http,String body,String basic,String way)
	{  
		String response="";
		InputStream inputs=null;
        byte[] entity=body.getBytes();
        try
        {  
            HttpURLConnection conn = (HttpURLConnection)new URL(http).openConnection();  
            //httpӲ                                          
            conn.setDoInput(true); 
            conn.setRequestProperty("Accept", "*/*");  
            conn.setRequestProperty("connection", "close");  
			conn.setRequestProperty("Authorization", basic);
            if(way.equals("POST"))
            {
            	conn.setDoOutput(true);
            	conn.setRequestProperty("Content-Length", String.valueOf(entity.length));
            }
            else
            {
            	conn.setDoOutput(false);
			}
            conn.setRequestMethod(way); 
            
            //óʱʱ
            conn.setConnectTimeout(15000);//15Sʱ 
            conn.setReadTimeout(30000);//30Sʱ  
            conn.connect();  
            //https
            if(way.equals("POST"))
            {
	            OutputStream outStream = conn.getOutputStream();
	            outStream.write(entity);
	            outStream.flush();
	            outStream.close();	            
            }
            //շ
            inputs=conn.getInputStream();           	
        	BufferedReader br = new BufferedReader(new InputStreamReader(inputs));
        	String lines="";
        	response="";
        	while((lines = br.readLine()) != null)
        	{
        		response+=lines;
        	}        		 
        	Log.i("Response=>", response);
        }
        catch(Exception e)
        {  
        	response="ERROR:"+e.toString();
        	Log.e("",e.toString());  
        }
        return response;
     } 
}
